/**************************************************************/
/* 	Nazev programu:             LOGGER-01                     */
/*  Autor programu:             LAZNICKA Pavel                */
/*  Posledni uprava dne:        06.02.2005                    */
/*  Typ procesoru: 				PHILIPS P89C51RC+JN (vyvoj)   */
/*  Typ procesoru:  			AT89C55             (serie)   */ 
/*  Frekvence krystalu:  		18.432 MHz                    */
/*  Parametry serioveho portu:	19200,N,8,1		              */
/**************************************************************/  

/* Tento zdrojovy text byl napsan v textovem editoru:         */
/* CRIMSON  EDITOR  3.51  Release  ( Freeware )               */ 
/* Copyright (C) 1999 - 2003 Ingyu KANG                       */ 

/* Program je urcen pro HI-TECH 8051 Compiler V 8.00          */
/* Copyright (c) 2002   HI-TECH Software                      */ 

/* Parametry kompilatoru:                                     */
/* c51.exe -8051 -ASMLIST logger_01.c eeprom.c -Lf            */

/* Funkci programu jsem simuloval pomoci:                     */
/* Analog Devices 812 Simulator                               */
/* Version 3.406 16 june 1998                                 */

/* Program ve formatu INTEL-HEX jsem nahral do                */
/* pameti FLASH 32 kBYTE procesoru PHILIPS P89C51RC+JN        */
/* pomoci software:                                           */
/* PHILIPS FLASH In System Programmer Version 2.29            */
/* od firmy HSM Electronics Inc - 1999                        */   

/* Program ve formatu INTEL-HEX jsem nahral do                */
/* pameti FLASH 20 kBYTE procesoru ATMEL AT89C55              */
/* v programatoru 51 & AVR prog                               * 
/* pomoci software:                                           */
/* PG4UW - universal control program for ELNEC programmers    */
/* Version 1.44/09 2002    

/* Snazil jsem se aby se program nedal zaseknout vysilanim    */
/* chybnych znaku po seriove smycce. Kdyz prijde neco, co     */
/* program nezna, tak program nic nedela a trpelive ceka      */
/* az dostane tu svoji spravnou kombinaci znaku               */ 
/* 		Ve vnitrni pameti RAM mikroprocesoru jsem vytvoril    */
/* buffer prijatych znaku o delce 9 bajtu. Posledni (osmy) 
/* znak je vzdy ENTER = 0xOD.                                 */
/* Do obsluhy preruseni od prijmu znaku po seriove smycce     */
/* RS-232C jsem napsal, ze se znaky obsazene v bufferu        */ 
/* prijatych znaku maji posunout zprava doleva o jednu        */
/* pozici podobne jako v posuvnem registru.                   */
/* 		Po prijmu kazdeho znaku se program vrati z obsluhy    */
/* preruseni do hlavniho programoveho cyklu. Zde pravidelne   */
/* vyhodnocuje obsah bufferu prijatych znaku. Pokud tam       */
/* najde prikaz, kteremu rozumi, tak jej vykona a cely        */
/* buffer prijatych znaku vymaze.                             */
/* 		Pokud prijdou znaky, kterym program nerozumi, tak     */
/* se tyto znaky posouvaji skrz buffer prijatych znaku        */
/* zprava doleva. Program po prijmu kazdeho noveho znaku      */
/* porovnava obsah bufferu s mnozinou znamych prikazu, nic    */
/* nedela a jenom ceka az se v bufferu objevi zase znama      */
/* kombinace znaku.                                           */
/*		Pokud prijde zkomoleny prikaz, tak program jeden      */
/* prikaz ignoruje, avsak jakmile prijde dalsi spravny        */
/* prikaz, tak by se program mel opet chytit a pokracovat     */
/* ve sve praci tam, kde skoncil.                             */   
 
#include    <string.h>
#include	<stdio.h>
#include    <math.h>
#include	<8052.h>   
#include    <intrpt.h> 

#include "24c256.h"

/* Funkce pro obsluhu preruseni programu                      */

ROM_VECTOR(0x23,serial_intr); 
ROM_VECTOR(0x2B,t2intr_intr); 

/* Prepinace pro podmineny preklad programu                   */ 

#define PROCES        	/* Realny procesor P89C51RC+JN        */
#define KRYSTAL_18      /* Frekvence krystalu 18.432 MHz      */
#define RS232           /* Seriova linka typu RS-232C         */

/* Zpravy vysilane z mikroprocesoru ( retezce znaku )         */
/* na seriovou linku typu RS-232C nebo RS-485                 */

#define ZPRAVA_B  "BEGIN OF MEMORY"
#define ZPRAVA_C  "VYROBNI CISLO: 12345"
#define ZPRAVA_D  "DISABLE TIMER T2"
#define ZPRAVA_E  "ENABLE TIMER T2"
#define ZPRAVA_V  "VERZE PRG: LOGGER-001"
#define ZPRAVA_Z1 "ZERO MEMORY START"
#define ZPRAVA_Z2 "ZERO MEMORY STOP" 

/* Mapovani portu mikroprocesoru                              */
/* Program je urcen pro vyvojovou desticku, ktera obsahuje    */
/* procesor P89C51RC+JN a seriovou I2C EEprom 24C256 a        */            
/* seriovy interface MAX232                                   */

#define LED_DIODA	P10      /* Port P1, Bit 00               */    
#define SELECT 		P12      /* Port P1, Bit 02               */
#define TRANS  		P23      /* Port P2, Bit 03               */
#define INT_0  		P32      /* Port P3, Bit 02               */    

/* Definice konstant pouzitych v komunikacnim protokolu       */

#define ENTER 0x0D

/* Konstanty pro casova zpozdeni - Procesor P89C51RC+JN       */
/* Frekvence krystalu 18.432 MHz                              */

#ifdef PROCES
#ifdef KRYSTAL_18

#define BAUD        0xFB   /*  251 ... Baudova rychlost       */  
#define TIME_RCAP2L 0x00   /*  0 ... Krystal 18.432 MHz 40 ms */
#define TIME_RCAP2H 0x10   /* 16 ... Krystal 18.432 MHz 40 ms */ 
#define MAXCOUNTER  0x19   /* 25 Doba pocitani impulsu        */

/* Konstanta, ktera definuje zpozdeni pro pamet EEprom        */

#define TIME_EEP    0x04B0  /* 1200 ... doba zpozdeni EEprom  */

/* Konstanta, ktera definuje zpozdeni pro diodu LED           */

#define TIME_LED    0xC350  /* 50000 ... doba zpozdeni LED    */ 

/* Konstanta, ktera definuje zpozdeni vysilani vice radku dat */

#define TIME_MULTI  0x07D0  /* 2000 ... zpozdeni vysilani dat */ 

#endif
#endif

/* Konstanty pro pristup k pameti EEprom                      */

#define ADR_SAVE      0x03EA /*  1002 Adresa Periody ukladani */
#define ADR_POCET     0x03F0 /*  1008 Pocet prenasenych radku */
#define ADR_KONST     0x3000 /* 12288 Adresa kal. konstanty   */
#define DATA_START    0x4000 /* 16384 Zacatek pameti dat      */
#define DATA_NUMBER   0x0E10 /*  3600 Pocet zaznamu v pameti  */

/* Definice promennych pouzitych v programu                   */ 

idata unsigned char Perioda_Save;
idata unsigned char Buffer[9];
idata unsigned char Counter;
idata unsigned char Fre_Low;
idata unsigned char Fre_Hig;  
idata unsigned char Counter_2;

idata unsigned short int Adresa_Write;
idata unsigned short int Adresa_Read;
idata unsigned short int Pocet_Radku;

idata float Kal_Konst;
idata float Value_Eep;
idata float Value_Dir;

/* Definice funkci pouzitych v programu                       */

void Delay_Time(unsigned short int Time);
void Nastav_Registry(void);
void Disable_Interrupts(void);
void Enable_Interrupts(void);
void Rozsvit_LED(void);
void Zhasni_LED(void);
void Disable_Timer(void);
void Enable_Timer(void);
void Nuluj_Buffer(void);
void Frekvence_Direct(void);
void Frekvence_Memory(void);
void Verze_Programu(void);
void Vyrobni_Cislo(void);
void Vypni_Casovace(void);
void Zapni_Casovace(void);
unsigned short int Get_Fre_Dir(void);
void Read_Memory(void);
void Write_Memory(void);
void Reading_Memory(void);
void Reading_Value(void);
void Reading_Multiply(void);
void Value_Direct(void);
void Kalibracni_Konstanta(void);
void Nulovani_Pameti(void);
void Begin_Memory(void);
void Nacti_Kalibracni_Konstantu(void);
void Aktualni_Adresa(void);
void Find_Free_Space(void);

/* Hlavni programu funkce MAIN */

main()
{
	/* Zakladni nastaveni registru mikroprocesoru             */
		
	Nastav_Registry();
				
	/* Vyzvednuti promennych parametru programu z pameti      */
	
	Perioda_Save = Eeprom_Read_Byte( ADR_SAVE );
	Pocet_Radku  = Eeprom_Read_Word( ADR_POCET );
	
	Nacti_Kalibracni_Konstantu();
	
	Counter_2 = 0x00;
			
	Rozsvit_LED();			/* Zablikat LED celkem 3x         */
	Delay_Time(TIME_LED);
	Zhasni_LED();
	Delay_Time(TIME_LED);
	Rozsvit_LED();
	Delay_Time(TIME_LED);
	Zhasni_LED();
	Delay_Time(TIME_LED);	
	Rozsvit_LED();
	Delay_Time(TIME_LED);
	Zhasni_LED();	
		
	Find_Free_Space();	/* Hledani volneho prostoru v pameti   */
			
	Rozsvit_LED();			/* Zablikat LED celkem 3x          */
	Delay_Time(TIME_LED);
	Zhasni_LED();
	Delay_Time(TIME_LED);
	Rozsvit_LED();	
	Delay_Time(TIME_LED);
	Zhasni_LED();
	Delay_Time(TIME_LED);
	Rozsvit_LED();	
	Delay_Time(TIME_LED);
	Zhasni_LED();			
							
	TI = 1;
	printf( "DATA LOGGER TYPE DL-01%c", ENTER );				
	Delay_Time( TIME_LED ); 
	TI = 1;
	printf( "LAZNICKA PAVEL - 2005%c", ENTER );	
		
	Zapni_Casovace();		/* START T0 a T2                  */		
	Enable_Interrupts();	/* Povoleni vsech preruseni       */
						
	Cyklus:					/* Zacatek mericiho cyklu         */
	
/* Prikaz pro ziskani aktualni adresy pro zapis do EEprom     */
/* Prikaz: @ + AKT-ADR + ENTER                                */  		

		if (( Buffer[0] == '@' ) && 
			( Buffer[1] == 'A' ) &&            
			( Buffer[2] == 'K' ) &&
            ( Buffer[3] == 'T' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'A' ) &&            
            ( Buffer[6] == 'D' ) &&            
            ( Buffer[7] == 'R' ) &&
            ( Buffer[8] == ENTER ))
		{
			Aktualni_Adresa();
	  	}		
	
/* Prikaz pro posunuti ukazovatka na zacatek pameti dat       */
/* Prikaz: @ + BEG-MEM + ENTER                                */  		

		if (( Buffer[0] == '@' ) && 
			( Buffer[1] == 'B' ) &&            
			( Buffer[2] == 'E' ) &&
            ( Buffer[3] == 'G' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'M' ) &&            
            ( Buffer[6] == 'E' ) &&            
            ( Buffer[7] == 'M' ) &&
            ( Buffer[8] == ENTER ))
		{
			Begin_Memory();
	  	}		
		
/* Prikaz pro zakaz preruseni od CASOVACE T2                  */
/* Prikaz: @ + DIS-TIM + ENTER                                */  		

		if (( Buffer[0] == '@' ) && 
            ( Buffer[1] == 'D' ) &&
            ( Buffer[2] == 'I' ) &&
            ( Buffer[3] == 'S' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'T' ) &&            
            ( Buffer[6] == 'I' ) &&            
            ( Buffer[7] == 'M' ) &&
            ( Buffer[8] == ENTER ))
		{
			Disable_Timer();
	  	}		  	
	  	
/* Prikaz pro zakaz preruseni od CASOVACE T2                  */
/* Prikaz:  @ + ENA-TIM + ENTER                               */  		

		if (( Buffer[0] == '@' ) && 
			( Buffer[1] == 'E' ) &&            
			( Buffer[2] == 'N' ) &&
            ( Buffer[3] == 'A' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'T' ) &&            
            ( Buffer[6] == 'I' ) &&            
            ( Buffer[7] == 'M' ) &&
            ( Buffer[8] == ENTER ))
		{
			Enable_Timer();
	  	}		  	

/* Prikaz pro vyslani okamzite namerene frekvence z vstupu T0 */
/* Prikaz: # + FRE-DIR + ENTER                                */  		

		if (( Buffer[0] == '#' ) && 
            ( Buffer[1] == 'F' ) &&
            ( Buffer[2] == 'R' ) &&
            ( Buffer[3] == 'E' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'D' ) &&            
            ( Buffer[6] == 'I' ) &&            
            ( Buffer[7] == 'R' ) &&
            ( Buffer[8] == ENTER ))
		{
			Frekvence_Direct();
	  	}		  	

/* Prikaz pro vyslani frekvence ulozene v pameti EEprom       */
/* Prikaz: # + FRE-MEM + ENTER                                */  		

		if (( Buffer[0] == '#' ) && 
            ( Buffer[1] == 'F' ) &&
            ( Buffer[2] == 'R' ) &&
            ( Buffer[3] == 'E' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'M' ) &&            
            ( Buffer[6] == 'E' ) &&            
            ( Buffer[7] == 'M' ) &&
            ( Buffer[8] == ENTER ))
		{
			Frekvence_Memory();
	  	}		  	
	  	
/* Prikaz pro vyslani kalibracni konstanty                    */
/* Prikaz: @ + KAL-KON + ENTER                                */  		

		if (( Buffer[0] == '@' ) && 
		    ( Buffer[1] == 'K' ) &&            
		    ( Buffer[2] == 'A' ) &&
            ( Buffer[3] == 'L' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'K' ) &&            
            ( Buffer[6] == 'O' ) &&            
            ( Buffer[7] == 'N' ) &&
            ( Buffer[8] == ENTER ))
		{
			Kalibracni_Konstanta();
	  	}	  	
	  		  		  		  		  		  		  		  		  		  		  		  		  	
/* Prikaz pro Cteni pameti eeprom a posunuti ukazovatka       */
/* Prikaz: # + HEX-MEM + ENTER                                */  		

		if (( Buffer[0] == '#' ) && 
            ( Buffer[1] == 'H' ) &&
            ( Buffer[2] == 'E' ) &&
            ( Buffer[3] == 'X' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'M' ) &&            
            ( Buffer[6] == 'E' ) &&            
            ( Buffer[7] == 'M' ) &&
            ( Buffer[8] == ENTER ))
		{
			Reading_Memory();
	  	}		  	

/* Prikaz pro prime zobrazeni namerene hodnoty                */
/* Prikaz: # + VAL-DIR + ENTER                                */  		

		if (( Buffer[0] == '#' ) && 
            ( Buffer[1] == 'V' ) &&
            ( Buffer[2] == 'A' ) &&
            ( Buffer[3] == 'L' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'D' ) &&            
            ( Buffer[6] == 'I' ) &&            
            ( Buffer[7] == 'R' ) &&
            ( Buffer[8] == ENTER ))
		{
			Value_Direct();
	  	}	  	
	  		  	
/* Prikaz pro Cteni pameti eeprom a posunuti ukazovatka       */
/* Prikaz: # + VAL-MEM + ENTER                                */  		

		if (( Buffer[0] == '#' ) && 
            ( Buffer[1] == 'V' ) &&
            ( Buffer[2] == 'A' ) &&
            ( Buffer[3] == 'L' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'M' ) &&            
            ( Buffer[6] == 'E' ) &&            
            ( Buffer[7] == 'M' ) &&
            ( Buffer[8] == ENTER ))
		{
			Reading_Value();
	  	}		  	

/* Prikaz pro Cteni mnoziny bajtu z pameti eeprom             */
/* Prikaz: # + VAL-MUL + ENTER                                */  		

		if (( Buffer[0] == '#' ) && 
            ( Buffer[1] == 'V' ) &&
            ( Buffer[2] == 'A' ) &&
            ( Buffer[3] == 'L' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'M' ) &&            
            ( Buffer[6] == 'U' ) &&            
            ( Buffer[7] == 'L' ) &&
            ( Buffer[8] == ENTER ))
		{
			Reading_Multiply();
	  	}		  	
	  	
	  		  		  		  		  		  		  		  		  		  		  		  	
/* Prikaz pro vyslani verze programu v mikroprocesoru         */
/* Prikaz: @ + VER-PRG + ENTER                                */  		

		if (( Buffer[0] == '@' ) && 
		    ( Buffer[1] == 'V' ) &&
		    ( Buffer[2] == 'E' ) &&
            ( Buffer[3] == 'R' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'P' ) &&            
            ( Buffer[6] == 'R' ) &&            
            ( Buffer[7] == 'G' ) &&
            ( Buffer[8] == ENTER ))
		{
			Verze_Programu();
	  	}		

/* Prikaz pro vyslani vyrobniho cisla hygrometru              */
/* Prikaz: @ + VYR-CIS + ENTER                                */  		

		if (( Buffer[0] == '@' ) && 
            ( Buffer[1] == 'V' ) &&
            ( Buffer[2] == 'Y' ) &&
            ( Buffer[3] == 'R' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'C' ) &&            
            ( Buffer[6] == 'I' ) &&            
            ( Buffer[7] == 'S' ) &&
            ( Buffer[8] == ENTER ))
		{
			Vyrobni_Cislo();
	  	}		  	

/* Cteni jednoho bajtu z pameti EEprom                        */
/* Prikaz @ + RAAAAXX + ENTER                                 */
		
		if (( Buffer[0] == '@' ) && 		
            ( Buffer[1] == 'R' ) && 			
            ( Buffer[6] == 'X' ) && 		    
            ( Buffer[7] == 'X' ) && 
		    ( Buffer[8] == ENTER )) 
		{
			Read_Memory();		
		}	 		
					  	
/* Zapis jednoho bajtu do pameti EEprom                       */
/* Prikaz @ + WAAAADD + ENTER                                 */

		if (( Buffer[0] == '@' ) && 
            ( Buffer[1] == 'W' ) &&
            ( Buffer[8] == ENTER )) 
  		{
			Write_Memory();		
		}		

/* Prikaz pro nulovani prostoru pro data v pameti EEprom      */
/* Prikaz: @ + ZER-MEM + ENTER                                */  		

		if (( Buffer[0] == '@' ) && 
            ( Buffer[1] == 'Z' ) &&
            ( Buffer[2] == 'E' ) &&
            ( Buffer[3] == 'R' ) &&
            ( Buffer[4] == '-' ) &&
            ( Buffer[5] == 'M' ) &&            
            ( Buffer[6] == 'E' ) &&            
            ( Buffer[7] == 'M' ) &&
            ( Buffer[8] == ENTER ))
		{
			Nulovani_Pameti();
	  	}	
												
/* Uschova namerene frekvence impulsu na vstupu COUNTERU T0   */
	  		  	
	if ( Counter == MAXCOUNTER )
	{
		Fre_Low = TL0;
		Fre_Hig = TH0;

		Zapni_Casovace();	

/* Tady budou prikazy pro ukladani dat do pameti EEprom       */
				
		Counter_2 = ( Counter_2 + 1 );
		
		if ( Counter_2 == Perioda_Save )
			{
				Rozsvit_LED();
				
				if ( Adresa_Write < ( DATA_START + ( DATA_NUMBER * 2 )))              
				{
					Eeprom_Write_Byte( Adresa_Write, Fre_Low );
					Delay_Time( TIME_EEP );
					Adresa_Write = ( Adresa_Write + 1 );

					Eeprom_Write_Byte( Adresa_Write, Fre_Hig );
					Delay_Time( TIME_EEP );
					Adresa_Write = ( Adresa_Write + 1 );				
				}
											
				Delay_Time(TIME_LED);
				Zhasni_LED();
				Counter_2 = 0x00;
			}	
	}  		  	
	  		  		  	
	goto Cyklus;	/* Konec mericiho cyklu                   */
}

/* Obsluha preruseni programu od prijmu znaku ze serie        */
/* Pri prijmu znaku se obsah prijimaciho bufferu posune       */
/* o jeden znak                                               */

bank2 interrupt void serial_intr(void)

{
	if(RI)
	{
		Buffer[0] = Buffer[1];		
		Buffer[1] = Buffer[2];		
		Buffer[2] = Buffer[3];				
		Buffer[3] = Buffer[4];		
		Buffer[4] = Buffer[5];				
		Buffer[5] = Buffer[6];				
		Buffer[6] = Buffer[7];			
		Buffer[7] = Buffer[8];	
		Buffer[8] = SBUF;
				
		RI = 0;
	}
	else
	{	
		TI = 0;
 	}
}

/* Obsluha preruseni programu od casovace T2                  */
/* Priznak TF2 je nutno nulovat pomoci softtware !!!          */ 
/* Frekvence krystalu je    18 432 000 [Hz]                   */
/* Preruseni je vyvolano 1x  za 40,000 [ms]                   */

bank3 interrupt void t2intr_intr(void)
{
	Counter = Counter + 1;		/* Inkrementace pocitadla     */    

		if ( Counter == MAXCOUNTER )
		{
			TR0     = 0;			/* STOP Timer T0          */
			TR2     = 0;            /* STOP Timer T2          */
		}	

		RCAP2L = 0x00; /* Pocatecni stav Timeru T2 je 0x1000  */ 					
		RCAP2H = 0x10; /* Pocatecni stav Timeru T2 je 0x1000  */	
				
	TF2 = 0;		/* Nulovat priznak preruseni od Timeru T2 */
} 

/* NASTAV_REGISTRY Nastaveni serioveho komunikacniho kanalu   */

void Nastav_Registry(void)
{
		Disable_Interrupts();	/* Zakaz vsech preruseni      */

/* FRONC,KLUCIK - Mikrokontrolery ATMEL s jadrem 8051 str. 54 */        
/* PCON - Konfiguracni registr pro rezimy snizene spotreby    */   
/* Dvojnasobna baudova prenosova rychlost                     */    	

		PCON = PCON | 0x80;			/* Baudrate double        */

/* FRONC,KLUCIK - Mikrokontrolery ATMEL s jadrem 8051 str. 42 */        
/* SCON - Konfiguracni registr serioveho kanalu               */ 
/* SM0    = 0 ... seriovy kanal pracuje v rezimu 1            */
/* SM1    = 1 ... seriovy kanal pracuje v rezimu 1            */
/* SM2    = 0 ... multiprocesorova komunikace je zakazana     */
/* REN    = 1 ... seriovy prijem dat je povolen               */
/* TB8    = 0 ... nevyuzivame devaty bit pri vysilani         */
/* RB8    = 0 ... nevyuzivame devaty bit pri prijmu           */
/* TI     = 1 ... priznak preruseni od vysilani znaku         */
/* RI     = 0 ... priznak preruseni od prijmu znaku           */   
    
		SCON = 0x52;

/* TH1 - Nastaveni prenosove baudove rychlosti                */	
/* Klucik, Fronc - Mikrokontrolery s jadrem 8051 - strana 43  */  
/* Seriovy kanal pracuje v rezimu 1                           */
/*                                                            */
/*               SMOD                                         */
/*              2         Oscilator Frequency                 */
/*		Baud = ------ * ---------------------                 */
/*              32      12 * [ 256 - (TH1)]                   */
/*                                                            */
/*                      SMOD                                  */
/*                     2       Oscilator Frequency            */
/*		TH1 = 256 - ( ---- * ---------------------- )         */ 
/*                     32         12 * Baud                   */
/*                                                            */
/* 		Oscilator Frequency = 18 432 000 [Hz]                 */
/*      Baud                = 19 200 [ bit/sec]               */
/*                                                            */
/*		TH1 = 251 dec = FB hex ( Krystal 18.432 MHz )         */ 	
    
		TH1 = BAUD;

/* TMOD - rezim cinnosti citacu - casovacu 0 a 1              */	
/* Klucik, Fronc - Mikrokontrolery s jadrem 8051 - strana 29  */
/* CASOVAC T1 je pouzit jako generator baudove rychlosti      */
/* CASOVAC T1 bude v rezimu 2 ( 8 bit reload timer )          */
/* CASOVAC T1 se zapina nastavenim bitu TR1                   */  	
/* CITAC   T0 pocita impulsy privedene na vstup T0            */
/* CITAC   TO je sestnactibitovy citac vnejsich impulsu       */
/* CITAC   T0 se zapina nastavenim bitu TR0                   */
/* GATE1 = 0 ... CASOVAC 1 nereaguje na externi vstup         */
/* C/T_1 = 0 ... CASOVAC 1 bude pracovat v rezimu CASOVACE    */ 	
/* M1_1  = 1 ... CASOVAC 1 bude pracovat v rezimu 2           */
/* M0_1  = 0 ... CASOVAC 1 bude pracovat v rezimu 2           */
/* GATE0 = 0 ... CITAC 0 nereaguje na externi vstup           */
/* C/T_0 = 1 ... CITAC 0 bude pracovat v rezimu 16-BIT CITACE */    
/* M1_0  = 0 ... CITAC 0 bude pracovat v rezimu 1             */
/* M0_0  = 1 ... CITAC 0 bude pracovat v rezimu 1             */   
      
		TMOD = 0x25;

/* FRONC,KLUCIK - Mikrokontrolery ATMEL s jadrem 8051 str. 30 */        
/* TCON - Konfiguracni registr casovacu T0 a T1               */         
/* TF1    = 0 ... priznakovy bit stavu citace T1              */
/* TR1    = 1 ... STOP citace T1                              */
/* TF0    = 0 ... priznakovy bit stavu citace T0              */ 
/* TR0    = 0 ... STOP citace T0                              */
/* IE1    = 0 ... priznak externiho preruseni od vstupu INT1  */
/* IT1    = 0 ... preruseni vznika pri logicke urovni "0"     */
/* IE0    = 0 ... priznak externiho preruseni od vstupu INT0  */
/* IT0    = 0 ... preruseni vznika pri logicke urovni "0"     */  
    
		TCON = 0x40;

/* T2CON - Konfiguracni registr CASOVACE T2                   */
/* Klucik, Fronc - Mikrokontrolery s jadrem 8051 - strana 32  */  	
/* TF2   = 0 ... Priznakovy bit-indikuje preplneni citace T2  */ 
/* EXF2  = 0 ... Externi priznakovy bit-externi ovladani T2EX */
/* RCLK  = 0 ... Priznakovy bit prijimace serioveho kanalu    */
/* TCLK  = 0 ... Priznakovy bit vysilace serioveho kanalu     */
/* EXEN2 = 0 ... Priznak povoleni pro vstup T2EX              */
/* TR2   = 0 ... CASOVAC T2 je dosud vypnut                   */
/* C/T2  = 0 ... T2 pracuje v rezimu CASOVACE                 */ 
/* CPRL2 = 0 ... Priznakovy bit rezimu zachyceni ( Capture )  */
  	
		T2CON  = 0x00;   /* Konfiguracni registr casovace T2  */		
		
/* IE - Nastaveni prerusovaciho systemu                       */
/* Klucik, Fronc - Mikrokontrolery s jadrem 8051 - strana 45  */
/* EA  = 0	globalni zakaz vsech preruseni  - zakazano        */
/* -     0  nepouzito                                         */
/* ET2 = 1  preruseni od CASOVACE T2 		- povoleno        */
/* ES  = 1	preruseni od serioveho kanalu   - povoleno        */
/* ET1 = 0	preruseni od CASOVACE T1        - zakazano        */
/* EX1 = 0  preruseni od ext. vstupu INT1   - zakazano        */
/* ET0 = 0  preruseni od CITACE T0       	- zakazano        */
/* EX0 = 0  preruseni od ext. vstupu INT0   - povoleno        */    			
  	
		IE=0x30;		
				
/* IP - Nastaveni priority prerusovaciho systemu              */
/* Klucik, Fronc - Mikrokontrolery s jadrem 8051 - strana 47  */
/* -     0  nepouzito                                         */
/* -     0  nepouzito                                         */
/* PT2 = 0  uroven priority CASOVACE T2		    - nizka       */					
/* PS  = 1  uroven priority serioveho kanalu    - vysoka      */	
/* PT1 = 0  uroven priority CASOVACE T1         - nizka       */
/* PX1 = 0  uroven priority ext. prerus. INT1   - nizka       */
/* PT0 = 0  uroven priority CITACE T0           - nizka       */
/* PX0 = 0  uroven priority ext. prerus. INT0   - nizka       */  
				
		IP=0x10;
}

/* DELAY_TIME Funkce generuje casove zpozdeni TIME            */
/* Maximalni hodnota parametru Time je 65535 tj. cca 0.65535s */  

void Delay_Time(unsigned short int Time)
{       
	while(( --Time ) != 0 );  
}

/* DISABLE_INTERRUPTS Funkce zakazuje vsechna preruseni       */

void Disable_Interrupts(void)
{
		EA = 0;		/* Globalni zakaz vsech preruseni         */
}

/* ENABLE_INTERRUPTS Funkce povoluje vsechna preruseni       */

void Enable_Interrupts(void)
{
		EA = 1;		/* Globalni zakaz vsech preruseni         */
}

/* ROZSVIT_LED Rozsviti indikacni diodu LED                   */

void Rozsvit_LED(void)
{
		LED_DIODA = 0;			/* Rozsvit LED SAVE           */
}

/* ZHASNI_LED Zhasne indikacni diodu LED                      */

void Zhasni_LED(void)
{
   		LED_DIODA = 1;			/* Zhasni LED SAVE            */
}

/* NULUJ_BUFFER Nuluje obsah bufferu prijimanych znaku        */

void Nuluj_Buffer(void)
{
        unsigned char p;
        for( p=0 ; p<=7 ; p++ ) 
        { Buffer[p] = 0x00; }	
}

/* VYPNI_CASOVACE - Zastavi cinnost casovacu T0 a T2          */ 

void Vypni_Casovace(void)
{
		Counter = 0x00;		/* Nulovani pocitadla pruchodu    */		
		
		TL0     = 0x00;		/* Nulovani pocitadla impulsu     */ 
		TH0     = 0x00;		/* Nulovani pocitadla impulsu     */

		RCAP2L  = 0x00;		/* Pocatecni stav casovace T2     */
		RCAP2H  = 0x10;		/* Pocatecni stav casovace T2     */
				
		TR0     = 0;		/* STOP CITACE T0                 */
		TR2     = 0;		/* STOP CITACE T2                 */
}	

/* ZAPNI_CASOVACE Nastavi pocatecni hodnotu predvolby         */
/* a potom opet spusti casovace T0 a T2                       */ 

void Zapni_Casovace(void)
{
		Counter = 0x00;		/* Nulovani pocitadla pruchodu    */		
		
		TL0     = 0x00;		/* Nulovani pocitadla impulsu     */ 
		TH0     = 0x00;		/* Nulovani pocitadla impulsu     */

		RCAP2L  = 0x00;		/* Pocatecni stav casovace T2     */
		RCAP2H  = 0x10;		/* Pocatecni stav casovace T2     */
				
		TR0     = 1;		/* START CITACE T0                */
		TR2     = 1;		/* START CITACE T2                */
}

/* GET_FRE_DIR vypocita okamzitou hodnotu frekvenci           */

unsigned short int Get_Fre_Dir(void)
{
	return (( 256 * Fre_Hig ) + Fre_Low );
}

/* Funkce pro prevod ASCII znaku na hexadecimalni cisla       */

unsigned char Ascii_To_Hex( char x ) 
{
	unsigned char RetValue = 0;

	if(( x >= '0' ) && ( x <= '9' ))
		{
		RetValue = x - 0x30;
		}
	else
	if(( x >= 'A' ) && ( x <= 'F' ))	
		{
		RetValue = x - 0x37;
		}	
	return RetValue;	
}

/* AKTUALNI_ADRESA_Posune ukazovatko na zacatek pameti dat    */
/* PRIKAZ: @ + AKT_ADR + ENTER                                */

void Aktualni_Adresa(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	
								
		TI = 1;					/* Priznak vysilani           */
	
		/* Vysilani aktualni adresy pro zapis do EEprom       */				
						
 		printf( "ADRESA-WRITE = %04X%c", Adresa_Write, ENTER );									
 		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */
}

/* BEGIN_MEMORY Posune ukazovatko na zacatek pameti dat       */
/* PRIKAZ: @ + BEG-MEM + ENTER                                */

void Begin_Memory(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	
		
		Adresa_Read = DATA_START;  /* Zacatek ulozenych dat   */
						
		TI = 1;					/* Priznak vysilani           */
	
 		printf( ZPRAVA_B"%c", ENTER );	/* Vysilani zpravy    */									
 		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */
}

/* DISABLE_TIMER Zakaze preruseni od CASOVACE T2              */
/* PRIKAZ: @ + DIS-TIM + ENTER                                */

void Disable_Timer(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */	
		Nuluj_Buffer();	        /* Mazani prijimaciho bufferu */	

		ET2 = 0;				/* Zakaz preruseni od T2      */

		TI  = 1;				/* Priznak vysilani           */		

 		printf( "DISABLE TIMER: T2%c", ENTER );									
		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		
}

/* ENABLE_TIMER Povoli preruseni od CASOVACE T2               */
/* PRIKAZ: @ + ENA-TIM + ENTER                                */

void Enable_Timer(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */	
		Nuluj_Buffer();	  		/* Mazani prijimaciho bufferu */	

		ET2 = 1;				/* Povoleni preruseni od T2   */		
		
		TI  = 1;				/* Priznak vysilani           */

 		printf( "ENABLE TIMER: T2%c", ENTER );									
		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		
}

/* FREKVENCE_DIRECT Vysle okamzitou hodnotu frekvence         */
/* PRIKAZ: # + FRE-DIR + ENTER                                */

void Frekvence_Direct(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	
									
		TI = 1;					/* Priznak vysilani           */

		printf( "FREKVENCE = %06u%c", Get_Fre_Dir(), ENTER );
		
        Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */         
}

/* FREKVENCE_MEMORY Precte jeden bajt z pameti EEprom         */
/* PRIKAZ: # + FRE-MEM + ENTER                                */

void Frekvence_Memory(void)
{    
		unsigned short int Frekv_Eep;
										 
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */        
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	                   
        
		/* Cteni dvou bajtu z pameti EEprom                   */
				           		
		Frekv_Eep = Eeprom_Read_Word( Adresa_Read );		
										
		TI  = 1;				/* Priznak vysilani           */

 		printf( "ADR: %06d VAL: %06u %c", 
 		         Adresa_Read, Frekv_Eep, ENTER );
 		         		
		Adresa_Read = Adresa_Read + 2;
						
        Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		
}

/* READ_MEMORY Precte jeden bajt z pameti EEprom              */
/* Prikaz @ + RAAAAXX + ENTER                                 */

void Read_Memory(void)
{    
		 
		unsigned char Data;		    /* Data v pameti EEprom   */
        unsigned short int Adresa;	/* Adresa pameti EEprom   */

	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */        
                                                
        Adresa =  (( 4096 * Ascii_To_Hex( Buffer[2] )) + 
                    ( 256 * Ascii_To_Hex( Buffer[3] )) +
                    (  16 * Ascii_To_Hex( Buffer[4] )) + 
                    (   1 * Ascii_To_Hex( Buffer[5] )));                   
                                      
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	                   
                   		
		/* Cteni jednoho bajtu z pameti EEprom                */
		
		Data = Eeprom_Read_Byte( Adresa );
		
		TI  = 1;				/* Priznak vysilani           */
				
 		printf( "READ ADRESA: %04X DATA: %02X %c", 
 		         Adresa, Data, ENTER );									
						
        Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		
}

/* READ_MEMORY Precte jeden bajt z pameti EEprom              */
/* PRIKAZ: # + HEX-MEM + ENTER                                */

void Reading_Memory(void)
{    
		unsigned short int Word_Eep;
		
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */        
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	                   
        
		/* Cteni dvou bajtu z pameti EEprom                */
		           		
		Word_Eep = Eeprom_Read_Word( Adresa_Read );
		
		TI  = 1;				/* Priznak vysilani           */
				
 		printf( "READ ADRESA: %04X DATA: %04X %c", 
 		         Adresa_Read, Word_Eep, ENTER );	
		
		Adresa_Read = Adresa_Read + 2;
						
        Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		
}

/* VALUE_DIRECT Vysle okamzitou hodnotu merene veliciny       */
/* PRIKAZ: # + VAL-DIR + ENTER                                */

void Value_Direct(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */		
	
		Nacti_Kalibracni_Konstantu();
												
		TI = 1;					/* Priznak vysilani           */
		
		Value_Dir = ( Kal_Konst * Get_Fre_Dir() );
				
 		printf( "VALUE = %08.3f %c", Value_Dir ,ENTER );			
		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		 
}

/* READING_VALUE Precte jeden bajt z pameti EEprom            */
/* PRIKAZ: # + VAL-MEM + ENTER                                */

void Reading_Value(void)
{    
		unsigned short int Frekv_Eep;
										 
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */        
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	                   
        
		/* Cteni dvou bajtu z pameti EEprom                   */
				           		
		Frekv_Eep = Eeprom_Read_Word( Adresa_Read );
		
		Value_Eep = ( Kal_Konst * Frekv_Eep );
				
		TI  = 1;				/* Priznak vysilani           */
				
 		printf( "ADR: %06d VAL: %08.3f %c", 
 		         Adresa_Read, Value_Eep, ENTER );
 		         		
		Adresa_Read = Adresa_Read + 2;
						
        Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		
}


/* READING_MULTIPLY Precte mnozinu bajtu z pameti EEprom      */
/* PRIKAZ: # + VAL-MUL + ENTER                                */

void Reading_Multiply(void)
{    
		unsigned short int Frekv_Eep;
		unsigned short int Index;
		
										 
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */        
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	                   
        
		
		for ( Index = 0 ; Index < Pocet_Radku ; Index++ )
		{
			/* Cteni dvou bajtu z pameti EEprom                   */
				           		
			Frekv_Eep = Eeprom_Read_Word( Adresa_Read );
		
			Value_Eep = ( Kal_Konst * Frekv_Eep );
				
			TI  = 1;				/* Priznak vysilani           */

 			printf( "ADR: %06d VAL: %08.3f %c", 
 		         Adresa_Read, Value_Eep, ENTER );
 		         		
			Delay_Time( TIME_MULTI ); 
			
			Adresa_Read = Adresa_Read + 2;
		}
								
        Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		
}

/* WRITE_MEMORY - Zapise jeden bajt do pameti EEprom          */
/* Prikaz @ + WAAAADD + Enter                                 */

void Write_Memory(void)
{    
        unsigned short int Adresa;	/* Adresa pameti EEprom   */	
		unsigned char Data;  	    /* Data v  pameti EEprom  */
        unsigned char Error;        /* Vysledek operace zapis */
		
        Error = 0;
        
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */		
		                                   
        Adresa =  (( 4096 * Ascii_To_Hex( Buffer[2] )) + 
                    ( 256 * Ascii_To_Hex( Buffer[3] )) +
                    (  16 * Ascii_To_Hex( Buffer[4] )) + 
                    (   1 * Ascii_To_Hex( Buffer[5] )));
		
        Data   =  (( 16 * Ascii_To_Hex( Buffer[6] )) + 
                   (  1 * Ascii_To_Hex( Buffer[7] )));                   
   
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */                   

		/* Zapis do EEprom        */ 		
		  
		Error = Eeprom_Write_Byte(Adresa,Data); 
		
		TI  = 1;				/* Priznak vysilani           */
		
		if ( Error == 0 )		
		{
 		printf( "WRITE ADRESA: %04X DATA: %02X %c", 
 		         Adresa, Data, ENTER );									
		}
 		else
 		{
		printf( "MEMORY ERROR !!! %c", ENTER );	
	 	}
 		          		         
        Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */			
}

/* VERZE_PROGRAMU Vysle aktualni vezi firmvare                */
/* PRIKAZ: @ + VER-PRG + ENTER                                */

void Verze_Programu(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	
		
		TI = 1;					/* Priznak vysilani           */
							
 		printf( ZPRAVA_V"%c", ENTER );									
 		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */
}

/* VYROBNI_CISLO Vysle vyrobni cislo pristroje                */
/* PRIKAZ: @ + VYR-CIS + ENTER                                */

void Vyrobni_Cislo(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	

		TI = 1;					/* Priznak vysilani           */
							
 		printf( ZPRAVA_C"%c", ENTER );									
 		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */
}

/* NULOVANI_PAMETI Vynuluje prostor pro data v pameti EEprom  */
/* PRIKAZ: @ + ZER-MEM + ENTER                                */

void Nulovani_Pameti(void)
{    
		unsigned short int Index;
		unsigned short int Adresa_Zero;	
			
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */	

		TI = 1;					/* Priznak vysilani           */
	
 		printf( ZPRAVA_Z1"%c", ENTER );									
 				
		Adresa_Zero = DATA_START;
		
		for( Index = 0 ; Index <= DATA_NUMBER ; Index++ )
		{
			Eeprom_Write_Word( Adresa_Zero, 0x0000 );
			
			Delay_Time( TIME_EEP );	
			
			Adresa_Zero = ( Adresa_Zero + 2 );
		}	
		
		TI = 1;					/* Priznak vysilani           */
							
 		printf( ZPRAVA_Z2"%c", ENTER );									
 				 		 		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */
}

/* KALIBRACNI_KONTANTA Vysle kalibracni konstantu z EEprom    */
/* PRIKAZ: @ + KAL-KON + ENTER                                */

void Kalibracni_Konstanta(void)
{    
	  	Disable_Interrupts();	/* Zakaz vsech preruseni      */
		Rozsvit_LED(); 			/* Rozsviceni LED diody       */
		Nuluj_Buffer();	  	    /* Mazani prijimaciho bufferu */		
	
		Nacti_Kalibracni_Konstantu();
												
		TI = 1;					/* Priznak vysilani           */

 		printf( "Konstanta = %012.8f %c", Kal_Konst, ENTER );			
		
   		Zhasni_LED();			/* Zhasnuti LED diody         */
 		Enable_Interrupts();	/* Povoleni vsech preruseni   */		 
}

/* NACTI_KALIBRACNI_KONSTANTU Nacte konstantu z EEprom        */

void Nacti_Kalibracni_Konstantu(void)
{
		unsigned short int Eeprom_Adress; /* Adresa v EEprom  */
		unsigned char Array[4];			  /* Pole 4 Bajty     */
		
		/* Adresa pro ulozeni Kalibracni konstanty */ 
		
		Eeprom_Adress = ADR_KONST;
										
		Array[3] = Eeprom_Read_Byte( Eeprom_Adress + 0 );
  		Array[2] = Eeprom_Read_Byte( Eeprom_Adress + 1 );
		Array[1] = Eeprom_Read_Byte( Eeprom_Adress + 2 );		
		Array[0] = Eeprom_Read_Byte( Eeprom_Adress + 3 );	

		memcpy( &Kal_Konst, Array, 4 );	/* Kopiruj 4 Bajty    */
}

/* FIND_FREE_SPACE - Funkce hleda nejblizsi                   */ 
/*                   volnou adresu v pameti EEprom            */  

void Find_Free_Space(void)
{
	unsigned char Low_Byte_Eep;
	unsigned char Hig_Byte_Eep;
	unsigned char Hledej;

	Hledej = 0xFF;
	Adresa_Write = ( DATA_START );
	
	while(( Hledej == 0xFF ) && 
	     ( Adresa_Write < ( DATA_START + DATA_NUMBER )))               
	{
		Low_Byte_Eep = Eeprom_Read_Byte( Adresa_Write + 0 );
		Hig_Byte_Eep = Eeprom_Read_Byte( Adresa_Write + 1 );
			
		if (( Low_Byte_Eep == 0x00 )  && ( Hig_Byte_Eep == 00 ))
		{
			Hledej = 0x00; 	
		}
		else 
		{ Adresa_Write = (Adresa_Write + 2 ); }
	}
}	



